#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <cstdio>

#define pb push_back

using namespace std;

typedef pair<int, int> ii;
typedef vector<int> vi;

inline int sqr(int x) { return x * x; }
inline int abs(int x) { return x > 0 ? x : -x; }

const int inf = 1000 * 1000 * 1000;

int n, m;
                                  
map<int, ii> wh;

int ri, rj;

/*inline int distMin(int x, int x1, int x2) {
	if (x >= x1 && x <= x2) return 0;
	return min(abs(x - x1), abs(x - x2));
}*/

inline int distMin(int x, int y, int x1, int y1, int x2, int y2) {
	return 
		max({abs(x-x1) + abs(y-y1), 
		    abs(x-x2) + abs(y-y2),
		    abs(x-x1) + abs(y-y2),
		    abs(x-x2) + abs(y-y1)}
		);
}

// 4 похожих друг на друга квадратичных спуска
bool checkInt(int dist, int x1, int y1, int x2, int y2) {
	if (x2 < x1) return false;	
	if (y2 < y1) return false;

	bool U = false;

	for (const auto & [t, p] : wh) {
		if (distMin(p.first, p.second, x1, y1, x2, y2) < dist)
			return false;
		if (p.first == x1 && p.second == y1) U = true;
	}

	if (x1 == x2 && y1 == y2) {
		if (U) {
			return false;
		}
			ri = x1, rj = y1;
		return true;
	}

	int mx = (x1 + x2) / 2;
	int my = (y1 + y2) / 2;
	if (checkInt(dist, x1, y1, mx, my)) return true;
	if (checkInt(dist, x1, my + 1, mx, y2)) return true;
	if (checkInt(dist, mx + 1, y1, x2, my)) return true;
	if (checkInt(dist, mx + 1, my + 1, x2, y2)) return true;

	return false;
}

bool checkIntFull(int dist, int x1, int y1, int x2, int y2) {
	if (x2 < x1) return false;
	if (y2 < y1) return false;
	if (x1 > ri || x1 == ri && y1 > rj) return false;

	bool U = false;

	for (auto & [t, p] : wh) {
		if (distMin(p.first, p.second, x1, y1, x2, y2) < dist)
			return false;

		if (p.first == x1 && p.second == y1) U = true;
	}

	if (x1 == x2 && y1 == y2) {
		if (U) {
			return false;
		}
		if (x1 < ri || x1 == ri && y1 < rj)
			ri = x1, rj = y1;
		return true;
	}

	int mx = (x1 + x2) / 2;
	int my = (y1 + y2) / 2;
	bool res = false;
	if (checkIntFull(dist, x1, y1, mx, my)) res = true;
	if (checkIntFull(dist, x1, my + 1, mx, y2)) res = true;
	if (checkIntFull(dist, mx + 1, y1, x2, my)) res = true;
	if (checkIntFull(dist, mx + 1, my + 1, x2, y2)) res = true;

	return res;
}

vector<vector<vector<int>>> v3(204, vector<vector<int>>(104, vector<int>(104,0)));

bool checkNewInt(int dist, int n,  int m, int &pi, int &pj) {
    for (int i = 0; i < n; ++i) {
	int s = 0;
	for (int j = 0; j < m; ++j) {
	   s += v3[dist][i][j];
	   if (s == 0) {
		pi = i;
		pj = j; 
	        return true;
	   }
	}
    }
    return false;
}

void print(const vector<vector<int>> &v, int n, int m) {
	for (const auto& vv: v) {
		int mm = m + 1;
		for (int e : vv) {
		    cout << e << " ";
		    mm--;
		    if (mm == 0) break;
		}
		n--;
		cout << endl;
		if (n<0) break;
	}
}

int main() {
	int k;
	cin >> n >> m >> k;

        std::vector<std::pair<int, int>> v;

	for (int i = 1; i <= k; ++i) {
	     int s, f;
	     cin >> s >> f;
	     v.push_back(std::make_pair(s, -i));
	     v.push_back(std::make_pair(f, i));
        }

        std::sort(v.begin(), v.end());

        int maxd = n + m + 3;

	for (int kk = 0; kk < 2*k; ++kk) {
		if (v[kk].second < 0) { // enter
			int down = 0, up = maxd;
			int pi;
			int pj;
			while (up - down > 1) {
				int t = (up + down) / 2;
				if (!checkNewInt(t, n, m, pi, pj))
					up = t;
				else
					down = t;
			}
			ri = 100500, rj = 100500;
			// ищем самую левую верхнюю точку
			checkNewInt(down, n, m, ri, rj);
			if (ri >= 100500 || rj >= 100500) {
			    cout << "-1 -1"  << endl;
	                } else {
			    cout << ri + 1 << " " << rj + 1 << "\n";
			    for (int dd = 0; dd < maxd; ++dd) {
				for (int i=0; i < n; ++i) {
				     int l = abs(i - ri);
				     int ddd = dd - l;
                                     if (ddd<0) continue;
				     int lrj = rj - ddd;
				     int rrj = rj + ddd + 1;
				     if (lrj < 0) {
					  lrj = 0;
				     }
				     if (rrj > m) {
					 rrj = m;
				     }

				     v3[dd][i][lrj]++;
				     v3[dd][i][rrj]--;
				}	
			    }
			}
			wh[-v[kk].second] = ii(ri, rj);
		} else {
			// удаляем
			auto [ri, rj] = wh[v[kk].second];
			wh.erase(v[kk].second);
			    for (int dd = 0; dd < maxd; ++dd) {
				for (int i=0; i < n; ++i) {
				     int l = abs(i - ri);
				     int ddd = dd - l;
				     if (ddd < 0) continue;
				     int lrj = rj - ddd;
				     int rrj = rj + ddd + 1;
				     if (lrj < 0) {
					  lrj = 0;
				     }
				     if (rrj > m) {
					 rrj = m;
				     }

				     v3[dd][i][lrj]--;
				     v3[dd][i][rrj]++;
				}	
			    }
		}
/*		if (kk == 0) {
			print(v3[3], n, m);
			cout << "---\n";
			print(v3[4], n, m);
		}*/
	}
	return 0;
}
