/* -*- mode: c; c-basic-offset: 4 -*- */

#include "checker2.h"
#include <math.h>

int main(int argc, char *argv[])
{
    checker_do_init(argc, argv, 1, 0, 0);

    int test_num = 0;
    const char *s = getenv("EJUDGE_TEST_NUM");
    if (s && *s) {
        test_num = strtol(s, NULL, 10);
    }

    int output_cells = 0, corr_cells = 0;
    double output_square = 0.0, corr_square = 0.0;

    checker_read_out_int("output_cells", 0, &output_cells);
    checker_read_corr_int("corr_cells", 0, &corr_cells);

    checker_read_out_double("output_square", 0, &output_square);
    checker_read_corr_double("corr_square", 0, &corr_square);

    checker_out_eof();
    checker_corr_eof();

    if (output_cells != corr_cells) {
        printf("%d\n", 0);
        fatal_WA("cell count mismatch: output: %d, correct: %d",
                 output_cells, corr_cells);
    }

    if (!checker_eq_double(output_square, corr_square, 1e-6)) {
        printf("%d\n", test_num == 1?0:3);
        fatal_WA("square mismatch: output: %.10g, correct: %.10g",
                 output_square, corr_square);
    }

    printf("%d\n", test_num == 1?0:4);
    checker_OK();
}
